package ding

import (
	"encoding/json"
	"fmt"
	"log"
)

const (
	MARKTYPE       = "markdown"
	TEXTTYPE       = "text"
	CONTENT_TEMPLE = "#  %s服务状态异常\r\n > 异常类型:%s  \r\n > 触发时间:%s  \r\n ###### Warning"
)

type DDAt struct {
	IsAtAll   bool     `json:"isAtAll"`
	AtMobiles []string `json:"atMobiles"`
}

type TextContent struct {
	Content string `json:"content,omitempty"`
}

type MarkdownContent struct {
	Title string `json:"title,omitempty"`
	Text  string `json:"text,omitempty"`
}

type DDMessage struct {
	MsgType  string          `json:"msgtype"`
	Markdown MarkdownContent `json:"markdown,omitempty"`
	Text     TextContent     `json:"text,omitempty"`
	At       DDAt            `json:"at"`
}

/**
* 获取可以使用的消息对象Json
*
* @return string
 */
func (m *DDMessage) process() string {
	data, err := json.Marshal(m)
	if err != nil {
		log.Panic(err)
	}
	return fmt.Sprintf("%s\n", data)
}

/**
* 初始化消息
*
* @return string
 */
func initMessage(status string, appName string, time string) string {
	var message DDMessage
	message.MsgType = MARKTYPE
	message.Markdown.Title = "日志报警"
	message.Markdown.Text = fmt.Sprintf(CONTENT_TEMPLE, appName, status, time)
	message.At.IsAtAll = false
	message.At.AtMobiles = []string{}

	messageJson := message.process()
	log.Println(messageJson)
	return messageJson
}
